--- src/backend/capi.cpp.orig	Sat Feb 12 15:06:23 2005
+++ src/backend/capi.cpp	Sat Feb 12 15:06:37 2005
@@ -863,8 +863,9 @@
 void
 Capi::readProfile() throw (CapiMsgError)
 {
+    CAPIProfileBuffer_t profilebuf;
 	unsigned char buf[64];
- 	_cdword buf2[4]; 
+ 	unsigned buf2[6];
 
 	// is CAPI correctly installed?
 	unsigned info=CAPI20_ISINSTALLED();
@@ -872,11 +873,11 @@
       		throw (CapiMsgError(info,"Error in CAPI20_ISINSTALLED: "+describeParamInfo(info),"Capi::getCapiInfo()"));
 
     	// retrieve number of installed controllers and create array for storing the descriptions
-    	info=CAPI20_GET_PROFILE (0, buf);
+    	info=CAPI20_GET_PROFILE (0, &profilebuf);
     	if (info!=0)
       		throw (CapiMsgError(info,"Error in CAPI20_GET_PROFILE: "+describeParamInfo(info),"Capi::getCapiInfo()"));
 
-	numControllers=buf[0]+(buf[1] << 8);
+	numControllers=C_GET_WORD(profilebuf.wCtlr);
 
 	// retrieve general information (kernel driver manufacturer, version of kernel driver)
 	if (capi20_get_manufacturer(0,buf))
@@ -884,7 +885,7 @@
 	else
 		capiManufacturer="unknown";
 
-	if (capi20_get_version(0, reinterpret_cast<unsigned char *>(buf2))) {
+	if (capi20_get_version(0, &buf2[0],&buf2[1],&buf2[2],&buf2[3],&buf2[4],&buf2[5])) {
 		stringstream tmp;
 		tmp << buf2[0] << "." << buf2[1] << "/" << buf2[2] << "." << buf2[3] << ends;
 		capiVersion=tmp.str();
@@ -901,38 +902,44 @@
 		else
 			profiles[i-1].manufacturer="unknown";
 			
-		info = CAPI20_GET_PROFILE(i, buf);
+		info = CAPI20_GET_PROFILE(i, &profilebuf);
 		if (info!=0)
 			throw (CapiMsgError(info,"Error in CAPI20_GET_PROFILE/2: "+Capi::describeParamInfo(info),"Capi::getCapiInfo()"));
 
-		profiles[i-1].bChannels=buf[2] + (buf[3]<<8);
+		profiles[i-1].bChannels=C_GET_WORD(profilebuf.wNumBChannels);
 
-		if (buf[4] & 0x08)
+		if (C_GET_DWORD(profilebuf.dwGlobalOptions) & CAPI_PROFILE_DTMF_SUPPORT)
 			profiles[i-1].dtmf=true;
 		else
 			profiles[i-1].dtmf=false;
 
-		if (buf[4] & 0x10)
+		if (C_GET_DWORD(profilebuf.dwGlobalOptions) & CAPI_PROFILE_SUPPLEMENTARY_SERVICES)
 			profiles[i-1].suppServ=true;
 		else
 			profiles[i-1].suppServ=false;
 
-		if (buf[8] & 0x02 && buf[12] & 0x02 && buf[16] & 0x01)
+		if (   C_GET_WORD(profilebuf.dwB1ProtocolSupport) & (1 << CAPI_B1_TRANSPARENT_64)
+            && C_GET_WORD(profilebuf.dwB2ProtocolSupport) & (1 << CAPI_B2_TRANSPARENT) 
+            && C_GET_WORD(profilebuf.dwB3ProtocolSupport) & (1 << CAPI_B3_TRANSPARENT) )
 			profiles[i-1].transp=true;
 		else
 			profiles[i-1].transp=false;
 
-		if (buf[8] & 0x10 && buf[12] & 0x10 && buf[16] & 0x10)
+		if (   C_GET_WORD(profilebuf.dwB1ProtocolSupport) & (1 << CAPI_B1_T30_MODEM)
+            && C_GET_WORD(profilebuf.dwB2ProtocolSupport) & (1 << CAPI_B2_T30_FAX_G3) 
+            && C_GET_WORD(profilebuf.dwB3ProtocolSupport) & (1 << CAPI_B3_T30_FAX_G3) )
 			profiles[i-1].fax=true;
 		else
 			profiles[i-1].fax=false;
 
-		if (buf[8] & 0x10 && buf[12] & 0x10 && buf[16] & 0x20)
+		if (   C_GET_WORD(profilebuf.dwB1ProtocolSupport) & (1 << CAPI_B1_T30_MODEM)
+            && C_GET_WORD(profilebuf.dwB2ProtocolSupport) & (1 << CAPI_B2_T30_FAX_G3) 
+            && C_GET_WORD(profilebuf.dwB3ProtocolSupport) & (1 << CAPI_B3_T30_FAX_G3_EXT) )
 			profiles[i-1].faxExt=true;
 		else
 			profiles[i-1].faxExt=false;
 
-		if (capi20_get_version(i,reinterpret_cast<unsigned char*>(buf2))) {
+	    if (capi20_get_version(i, &buf2[0],&buf2[1],&buf2[2],&buf2[3],&buf2[4],&buf2[5])) {
 			stringstream tmp;
 			tmp << buf2[0] << "." << buf2[1] << "/" << buf2[2] << "." << buf2[3];
 			profiles[i-1].version=tmp.str();
